#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float GameTime;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    if (color.a < 0.1) {
        discard;
    }
    if (distance(color.rgb, vec3(0.988, 0.325, 0.988)) < 0.003) {
        // Epic Rarity
        fragColor = linear_fog(vec4(0.994, 0.312, 0.853, color.a) * (sin(mod(vertexDistance, 6.28318530718) + (GameTime * 5000)) / 2 + 1.4), vertexDistance, FogStart, FogEnd, FogColor);
    } else if (distance(color.rgb, vec3(0.325, 0.988, 0.988)) < 0.003) {
        // Rare Rarity
        fragColor = linear_fog(vec4(0.333, 0.902, 1.0, color.a) * (sin(mod(vertexDistance, 6.28318530718) + (GameTime * 5000)) / 2 + 1.4), vertexDistance, FogStart, FogEnd, FogColor);
    } else if (distance(color.rgb, vec3(0.988, 0.988, 0.325)) < 0.003) {
        // Unrare Rarity
        fragColor = linear_fog(vec4(0.988, 0.752, 0.165, color.a) * (sin(mod(vertexDistance, 6.28318530718) + (GameTime * 5000)) / 2 + 1.4), vertexDistance, FogStart, FogEnd, FogColor);
    } else {
        fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
    }
    
}
